#line 1 "dhcpservice.c"

























 

#line 1 "dhcpservice.h"

























 




#line 1 "udpservice.h"
























 




#line 1 "types.h"
























 





typedef char SCHAR ;
typedef unsigned char UCHAR ;
typedef short int SSHORT ;
typedef unsigned short int USHORT ;
typedef long int SLONG ;
typedef unsigned long ULONG ;





#line 31 "udpservice.h"
#line 1 "ipservice.h"
























 





#line 1 "emacdriver.h"
























 




#line 31 "emacdriver.h"







typedef struct {
                 UCHAR                DestinMACAddress [ 6 ] ;   
                 UCHAR                SourceMACAddress [ 6 ] ;   
                 USHORT               LengthOrType ;                             
               } EtherPackedHeaderRecT ;                                         












typedef struct {
                 ULONG         Length ;
                 ULONG         Index ;

                 UCHAR         Data [ ] ;
               } OSFrameRecT ;
typedef OSFrameRecT * PtrOSFrameRecT ;

typedef enum { Mode_10MBIT , Mode_100MBIT , Mode_AutoNeg } EtherSpeedMode ;




typedef ULONG ( * SendFrameServiceProcT ) ( OSFrameRecT *   ) ;
                                         
                                         
typedef void ( * FrameServiceProcT ) ( OSFrameRecT *   ) ;

typedef PtrOSFrameRecT ( * AllocFrameMemoryProcT ) ( ULONG   ) ;
                                         

typedef void ( * DeallocFrameMemoryProcT ) ( PtrOSFrameRecT   ) ;

typedef void ( * VoidServiceProcT ) ( void ) ;

typedef struct {
                 UCHAR                   InterfaceMACAddress [ 6 ] ;
                 VoidServiceProcT        CheckEthInterface ;                 
                 FrameServiceProcT       InterfaceProcessFrame ;             
                 AllocFrameMemoryProcT   InterfaceAllocFrameMemory ;         
                 DeallocFrameMemoryProcT InterfaceDeallocFrameMemory ;       
                 SendFrameServiceProcT   InterfaceSendFrame ;                
               } EMACInstanceRecT ;
typedef EMACInstanceRecT * PtrEMACInstanceRecT ;
							 
extern EMACInstanceRecT EMACInstanceRec ;

extern EMACInstanceRecT * InitPHYLayerInstance ( UCHAR *          ,
                                                 EtherSpeedMode   ) ;

#line 32 "ipservice.h"
#line 33 "ipservice.h"










#line 54 "ipservice.h"

typedef struct {
                 USHORT          ValidElement ;
                 USHORT          LifeTime ;
                 UCHAR           MACAddress [ 6 ] ;
                 ULONG           IPAddress ;
               } ARPTableElementRecT ;
typedef ARPTableElementRecT * PtrARPTableElementRecT ;



typedef struct {
                 UCHAR             Vers ;
                 UCHAR             HLen ;
                 UCHAR             ServiceType ;
                 UCHAR             Flags ;
                 UCHAR             TTL ;
                 UCHAR             Protocol ;
                 USHORT            TotalLength ;
                 USHORT            Identification ;
                 USHORT            FragmentOffs ;
                 USHORT            HeaderChecksum ;
                 ULONG             SourceIPAddress ;
                 ULONG             DestinationIPAddress ;
               } IPHeaderRecT ;

struct _IPLayerInstanceRec ;

typedef struct _IPLayerInstanceRec * PtrIPLayerInstanceRecT ;

typedef void ( * TCPTimerPoolServiceProcT ) ( void *   ) ;
typedef void ( * VoidIPLayerServiceProcT ) ( PtrIPLayerInstanceRecT   ) ;
typedef void ( * IPPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                          PtrOSFrameRecT           ,
                                          ULONG                    ) ;
typedef void ( * ProcessPackedServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                               PtrOSFrameRecT           ) ;
typedef void ( * ProcessProtPServiceProcT ) ( PtrIPLayerInstanceRecT   ,
                                              IPHeaderRecT *           ,
                                              PtrOSFrameRecT           ) ;

typedef struct _IPLayerInstanceRec {
                 void *                    UDPInstanceEntry ;
                 void *                    TCPInstanceEntry ;
                 ARPTableElementRecT       ARPTable [ 8 ] ;
                 ULONG                     MyLocalIPAddress ;
                 ULONG                     MyLocalNetMask ;
                 ULONG                     MyDefaultGWIPAddress ;
                 EMACInstanceRecT *        InterfaceInstance ;
                 ProcessPackedServiceProcT OthFrameProcessSerevice ;
                 ProcessPackedServiceProcT ARPProcessService ;
                 ProcessProtPServiceProcT  ICMPProcessService ;
                 ProcessProtPServiceProcT  ICMPEchoProcessService ;
                 ProcessProtPServiceProcT  UDPProcessService ;
                 ProcessProtPServiceProcT  TCPProcessService ;
                 ProcessPackedServiceProcT IPProcessService ;
                 TCPTimerPoolServiceProcT  TCPTimerPoolService ;
                 VoidIPLayerServiceProcT   DiagARPTableService ;
                 VoidIPLayerServiceProcT   IPLayerPoolService ;
                 VoidIPLayerServiceProcT   StandardTimeService ;
                 VoidIPLayerServiceProcT   ExtraTimeService ;
                 IPPackedServiceProcT      SendIPPackedService ;
                 IPPackedServiceProcT      AddToSendQueueService ;
               } IPLayerInstanceRecT ;

extern void SetIPAdresses ( PtrIPLayerInstanceRecT   ,
                            ULONG                    ,
                            ULONG                    ,
                            ULONG                    ) ;

extern PtrEMACInstanceRecT GetEMACInstance ( PtrIPLayerInstanceRecT   ) ;

extern PtrIPLayerInstanceRecT InitIPLayerInstance ( EMACInstanceRecT *   ,
                                                    ULONG                ,
                                                    ULONG                ) ;

#line 32 "udpservice.h"







struct _UDPLayerInstanceRec ;
typedef struct _UDPLayerInstanceRec * PtrUDPLayerInstanceRecT ;

struct _UDPSocketDescriptionRec ;
typedef struct _UDPSocketDescriptionRec * PtrUDPSocketDescriptionRecT ;

typedef void ( * AnyUDPRecvEventServProcT ) ( ULONG    ,
                                              USHORT   ,
                                              ULONG    ,
                                              USHORT   ,
                                              void *   ,
                                              USHORT   ) ;

typedef void ( * SocketUDPRecvEventServProcT ) ( PtrUDPSocketDescriptionRecT   ,
                                                 ULONG                         ,
                                                 USHORT                        ,
                                                 ULONG                         ,
                                                 USHORT                        ,
                                                 void *                        ,
                                                 USHORT                        ) ;

typedef struct _UDPSocketDescriptionRec
               {
                 USHORT                       ListenPortNo ;
                 SocketUDPRecvEventServProcT  ListenService ;
                 PtrUDPLayerInstanceRecT      UDPLayerInstanceLink ;
                 PtrUDPSocketDescriptionRecT  NextSocketLink ;
               } UDPSocketDescriptionRecT ;

typedef struct _UDPLayerInstanceRec
               { PtrIPLayerInstanceRecT       IPLayerInstance ;
                 AnyUDPRecvEventServProcT     DefaultListenService ;
                 PtrUDPSocketDescriptionRecT  ListenSocketTopEntry ;
                 USHORT                       LastLocalPort ;
               } UDPLayerInstanceRecT ;






extern USHORT UDPSendData ( PtrUDPSocketDescriptionRecT   ,
                            ULONG                         ,
                            USHORT                        ,
                            void *                        ,
                            USHORT                        ) ;

extern PtrUDPSocketDescriptionRecT AllocateUDPSocket ( PtrUDPLayerInstanceRecT   ) ;

extern void DeallocateUDPSocket ( PtrUDPSocketDescriptionRecT   ) ;




extern USHORT BindUDPSocket ( PtrUDPSocketDescriptionRecT   ,
                              USHORT                        ) ;

extern void SetUDPListen ( PtrUDPSocketDescriptionRecT   ,
                           SocketUDPRecvEventServProcT   ) ;

extern void SetDefaultUDPListen ( PtrUDPLayerInstanceRecT    ,
                                  AnyUDPRecvEventServProcT   ) ;

extern PtrUDPSocketDescriptionRecT CreateUDPSocket ( PtrUDPLayerInstanceRecT   ) ;

extern void UDPInitInstance ( PtrUDPLayerInstanceRecT   ,
                              PtrIPLayerInstanceRecT    ) ;

extern PtrUDPLayerInstanceRecT GetUDPInstance ( PtrUDPSocketDescriptionRecT   ) ;

extern PtrIPLayerInstanceRecT GetIPInstanceFromUDPInstance ( PtrUDPLayerInstanceRecT   ) ;

extern PtrUDPLayerInstanceRecT StandardAddUDPInstance ( PtrIPLayerInstanceRecT   ) ;

#line 32 "dhcpservice.h"
#line 33 "dhcpservice.h"
#line 1 "systime.h"
























 




#line 31 "systime.h"

typedef void ( * TimeServiceProcT ) ( void *   ) ;

typedef struct {
                 ULONG             BellTime ;
                 void *            CallParam ;
                 TimeServiceProcT  CallService ;
               } TimeQueueRecT ;
typedef TimeQueueRecT * PtrTimeQueueRecT ;


extern ULONG GetRandom ( void ) ;
  
extern void SysTimeEnevtService ( void ) ;

extern PtrTimeQueueRecT AttachTimer ( ULONG               ,
                                      TimeServiceProcT    ,
                                      void *              ) ;

extern void DetachTimer ( PtrTimeQueueRecT   ) ;

void SysTimerPool ( void ) ;

void InitSysTime ( void ) ;

#line 34 "dhcpservice.h"


typedef void ( * RecVDHCPDataNotifyServProcT ) ( PtrUDPSocketDescriptionRecT   ,
                                                 ULONG                         ,
                                                 ULONG                         ,
                                                 ULONG                         ) ;



typedef struct { PtrUDPLayerInstanceRecT      UDPLayerInstance ;
                 RecVDHCPDataNotifyServProcT  UserDCHPDataNotifyService ;
                 PtrUDPSocketDescriptionRecT  DHCPSocket ;
                 UCHAR                        DeviceName [ 16 ] ;
                 ULONG                        XID ;
                 ULONG                        TimeOut ;
                 ULONG                        Client_IP ;
                 ULONG                        Server_ID ;
                 PtrTimeQueueRecT             TimeOutService ;
                 USHORT                       Command ;
                 USHORT                       Retry ;
               } DHCPLayerInstanceRecT ;
typedef DHCPLayerInstanceRecT * PtrDHCPLayerInstanceRecT ;


extern void DHCPClientRenew ( PtrDHCPLayerInstanceRecT   ) ;

extern USHORT StartDHCPService ( PtrDHCPLayerInstanceRecT      ,
                                 RecVDHCPDataNotifyServProcT   ) ;

extern void StopDHCPService ( PtrDHCPLayerInstanceRecT   ) ;

extern PtrDHCPLayerInstanceRecT AllocateDHCPClientInstance ( PtrUDPLayerInstanceRecT   ,
                                                             UCHAR *                   ) ;


#line 29 "dhcpservice.c"
#line 30 "dhcpservice.c"
#line 31 "dhcpservice.c"
#line 32 "dhcpservice.c"
#line 33 "dhcpservice.c"
#line 1 "frameutil.h"
























 




#line 31 "frameutil.h"
#line 32 "frameutil.h"
#line 33 "frameutil.h"

extern USHORT AutoIdentyficationCounter ;

extern USHORT CalculateChecksum ( void *   ,
                                  USHORT   ) ;

extern USHORT CalculateTCPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern USHORT CalculateUDPChecksum ( ULONG    ,
                                     ULONG    ,
                                     void *   ,
                                     USHORT   ) ;

extern void GetByteArrayField ( void *           ,
                                PtrOSFrameRecT   ,
                                USHORT           ,
                                USHORT           ) ;

extern UCHAR GetUCHARField ( PtrOSFrameRecT   ,
                             USHORT           ) ;

extern USHORT GetUSHORTSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ) ;

extern ULONG GetULONGSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddByteArrayField ( PtrOSFrameRecT   ,
                                void *           ,
                                USHORT           ) ;

extern void AddDuplByteField ( PtrOSFrameRecT   ,
                               UCHAR            ,
                               USHORT           ) ;

extern void AddByteField ( PtrOSFrameRecT   ,
                           UCHAR            ) ;

extern void AddUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void AddULONGSwapField ( PtrOSFrameRecT   ,
                                ULONG            ) ;

extern void PutByteArrayField ( PtrOSFrameRecT   ,
                                USHORT           ,
                                void *           ,
                                USHORT           ) ;

extern void PutUSHORTSwapField ( PtrOSFrameRecT   ,
                                 USHORT           ,
                                 USHORT           ) ;

extern void PutUSHORTNoSwapField ( PtrOSFrameRecT   ,
                                   USHORT           ,
                                   USHORT           ) ;

extern void StartEthFrame ( PtrOSFrameRecT   ,
                            UCHAR *          ,
                            UCHAR *          ,
                            USHORT           ) ;

extern void CreateIPHeader ( PtrOSFrameRecT   ,
                             UCHAR            ,
                             ULONG            ,
                             ULONG            ) ;

extern void SkipByteArrayField ( PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern void ReadByteArrayField ( void *           ,
                                 PtrOSFrameRecT   ,
                                 USHORT           ) ;

extern UCHAR ReadUCHARField ( PtrOSFrameRecT   ) ;

extern USHORT ReadUSHORTSwapField ( PtrOSFrameRecT   ) ;

extern ULONG ReadULONGSwapField ( PtrOSFrameRecT   ) ;

extern void GetEthHeader ( EtherPackedHeaderRecT *   ,
                           PtrOSFrameRecT            ) ;

extern void GetIPHeader ( IPHeaderRecT *   ,
                          PtrOSFrameRecT   ) ;

extern void SetIPHeaderOrgin ( PtrOSFrameRecT   ) ;

extern USHORT SwapBytes ( USHORT   ) ;

#line 34 "dhcpservice.c"
#line 1 "uart0.h"























 




#line 30 "uart0.h"

extern void UART0InitEnvir ( void ) ;

extern void UART0HardwInit( ULONG   ,
                            UCHAR   ,
                            ULONG   ) ;

extern void UART0InputReset ( void ) ;

extern void UART0Send ( UCHAR   ) ;

extern void UART0SendString ( UCHAR *   ) ;

extern ULONG UART0DataPresent ( void ) ;

extern UCHAR UART0GetData ( void ) ;

extern UCHAR UART0Working ( void ) ;



#line 35 "dhcpservice.c"
#line 1 "trace.h"
























 




#line 31 "trace.h"
#line 32 "trace.h"
#line 33 "trace.h"

extern void traceDHCP ( UCHAR * UDPDataBuffer , USHORT UDPDataSize ) ;


extern void TraceUDPHeader ( PtrOSFrameRecT   ) ;

extern void TraceFrame ( PtrOSFrameRecT   ) ;

extern void TraceIPHeader ( IPHeaderRecT *   ) ;

extern void TraceETHHeader ( EtherPackedHeaderRecT *   ) ;

extern void TraceMAC ( UCHAR *   ) ;

extern void TraceIP ( ULONG   ) ;

extern void TraceUCHAR ( UCHAR   ) ;

extern void TraceUSHORT ( USHORT   ) ;

extern void TraceUSHORTdec ( USHORT   ) ;

extern void TraceULONG ( ULONG   ) ;

extern void traceBlock( UCHAR *   , USHORT   ) ;

#line 36 "dhcpservice.c"











 
#line 59 "dhcpservice.c"

 
#line 69 "dhcpservice.c"

#line 76 "dhcpservice.c"







static DHCPLayerInstanceRecT LocalDHCPLayerInstance ;

static USHORT SendDHCPRequest ( PtrDHCPLayerInstanceRecT   ) ;


static void DHCPLeaveTimeOutNotify ( void * CallParam )
{
  PtrDHCPLayerInstanceRecT DHCPInstance ;
  PtrIPLayerInstanceRecT IPLayerInstance ;
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
   
  DHCPInstance = ( PtrDHCPLayerInstanceRecT ) CallParam ;
  UDPLayerInstance = DHCPInstance -> UDPLayerInstance ;
  IPLayerInstance = UDPLayerInstance -> IPLayerInstance ;
  if ( DHCPInstance -> TimeOutService )
  {
    DetachTimer ( DHCPInstance -> TimeOutService ) ;
    DHCPInstance -> TimeOutService = ( void * ) 0 ;
  }   ;
  SetIPAdresses ( IPLayerInstance , 0 , 0 , 0 ) ;
  DHCPClientRenew ( DHCPInstance ) ;
}  


static ULONG MagicID ( PtrUDPLayerInstanceRecT UDPLayerInstance )
{
  ULONG Status ;
  PtrIPLayerInstanceRecT IPLayerInstance ;
  EMACInstanceRecT * InterfInstance ;
   
  IPLayerInstance = UDPLayerInstance -> IPLayerInstance ;
  InterfInstance = IPLayerInstance -> InterfaceInstance ;
  Status = ( ( ULONG ) InterfInstance -> InterfaceMACAddress [ 2 ] << 24 ) |
           ( ( ULONG ) InterfInstance -> InterfaceMACAddress [ 3 ] << 16 ) |
           ( ( ULONG ) InterfInstance -> InterfaceMACAddress [ 4 ] << 8 ) |
           ( ( ULONG ) InterfInstance -> InterfaceMACAddress [ 5 ] ) ;
  Status ^= GetRandom ( ) ;
  return ( Status ) ;
}  


static ULONG LocGetULONG ( UCHAR * DataBuffer )
{
  ULONG Temp ;
   
  Temp = ( ULONG ) ( * DataBuffer ++ ) ;
  Temp = ( Temp << 8 ) | ( ULONG ) ( * DataBuffer ++ ) ;
  Temp = ( Temp << 8 ) | ( ULONG ) ( * DataBuffer ++ ) ;
  Temp = ( Temp << 8 ) | ( ULONG ) ( * DataBuffer ++ ) ;
  return ( Temp ) ;
}  


static void DHCPDataRecvNotify ( PtrUDPSocketDescriptionRecT UDPSocket ,
                                 ULONG                       SenderIPAddress ,
                                 USHORT                      SenderPortNo ,
                                 ULONG                       DestIPAddress ,
                                 USHORT                      DestPortNo ,
                                 void *                      UDPDataBuffer ,
                                 USHORT                      UDPDataSize )
{
  PtrDHCPLayerInstanceRecT DHCPInstance ;
  PtrIPLayerInstanceRecT IPLayerInstance ;
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
  UCHAR * DataBuffer ;
  UCHAR Operation ;
  UCHAR Option ;
  UCHAR OptionSize ;
  UCHAR MessageType ;
  USHORT Reply ;
  ULONG XID ;
  ULONG ClientIP ;
  ULONG Cookie ;
  ULONG Server_ID ;
  ULONG SubNet ;
  ULONG GateWay ;
  ULONG Duration ;
   
traceDHCP(UDPDataBuffer , UDPDataSize);
  DHCPInstance = & LocalDHCPLayerInstance ;
  Reply = ( 0 ) ;
  MessageType = 0 ;
  Server_ID = 0 ;
  SubNet = 0 ;
  GateWay = 0 ;
  Duration = 0xffffffff ;
  DataBuffer = ( UCHAR * ) UDPDataBuffer ;
  if ( ( DHCPInstance -> Command ) && ( UDPDataSize >= ( 44 + 64 + 128 + 8 ) ) )
  {
    Operation = * DataBuffer ++ ; UDPDataSize -- ;
    DataBuffer += 3 ; UDPDataSize -= 3 ;
    XID = LocGetULONG ( DataBuffer ) ;
    DataBuffer += 4 ; UDPDataSize -= 4 ;
    DataBuffer += 8 ; UDPDataSize -= 8 ;
    ClientIP = LocGetULONG ( DataBuffer ) ;
    DataBuffer += 4 ; UDPDataSize -= 4 ;
    DataBuffer += 24 ; UDPDataSize -= 24 ;
    if ( ( Operation == 2 ) && ( XID == DHCPInstance -> XID ) && ClientIP )
    {
      DataBuffer += ( 64 + 128 ) ;
      Cookie = LocGetULONG ( DataBuffer ) ;
      DataBuffer += 4 ; UDPDataSize -= 4 ;
      if ( Cookie == 0x63825363 )
      {
        while ( UDPDataSize )
        {
          Option = * DataBuffer ++ ; UDPDataSize -- ;
          if ( Option == 0 )
          {
            continue ;
          }   ;
          if ( Option == 255 )
          {
            break ;
          }   ;
          OptionSize = * DataBuffer ++ ; UDPDataSize -- ;
          if ( OptionSize > UDPDataSize )
          {
            break ;
          }   ;
          switch ( Option )
          {
            case 53 :
              if ( OptionSize == 1 )
              {
                MessageType = * DataBuffer ++ ; UDPDataSize -- ;
                OptionSize = 0 ;
              }   ;
              break ;
            case 54 :
              if ( OptionSize == 4 )
              {
                Server_ID = LocGetULONG ( DataBuffer ) ;
                DataBuffer += 4 ; UDPDataSize -= 4 ;
                OptionSize = 0 ;
              }   ;
              break ;
            case 1 :
              if ( OptionSize == 4 )
              {
                SubNet = LocGetULONG ( DataBuffer ) ;
                DataBuffer += 4 ; UDPDataSize -= 4 ;
                OptionSize = 0 ;
              }   ;
              break ;
            case 3 :
              if ( OptionSize == 4 )
              {
                GateWay = LocGetULONG ( DataBuffer ) ;
                DataBuffer += 4 ; UDPDataSize -= 4 ;
                OptionSize = 0 ;
              }   ;
              break ;
            case 51 :
              if ( OptionSize == 4 )
              {
                Duration = LocGetULONG ( DataBuffer ) ;
                DataBuffer += 4 ; UDPDataSize -= 4 ;
                OptionSize = 0 ;
              }   ;
              break ;
          }   ;
          if ( OptionSize )
          {
            DataBuffer += OptionSize ;
            UDPDataSize -= OptionSize ;
          }   ;
        }   ;
        UDPLayerInstance = UDPSocket -> UDPLayerInstanceLink ;
        IPLayerInstance = UDPLayerInstance -> IPLayerInstance ;
        switch ( MessageType )
        {
          case 2 :
            if ( DHCPInstance -> Command == 1 )
            {
              if ( DHCPInstance -> TimeOutService )
              {
                DetachTimer ( DHCPInstance -> TimeOutService ) ;
                DHCPInstance -> TimeOutService = ( void * ) 0 ;
              }   ;
              DHCPInstance -> Command = 3 ;
              DHCPInstance -> Retry = 4 ;
              DHCPInstance -> Client_IP = ClientIP ;
              DHCPInstance -> Server_ID = Server_ID ;
              Reply = ( 1 ) ;
            }   ;
            break ;
          case 5 :
            if ( DHCPInstance -> Command == 3 )
            {
              if ( DHCPInstance -> TimeOutService )
              {
                DetachTimer ( DHCPInstance -> TimeOutService ) ;
                DHCPInstance -> TimeOutService = ( void * ) 0 ;
              }   ;
              SetIPAdresses ( IPLayerInstance , ClientIP , SubNet , GateWay ) ;
              if ( DHCPInstance -> UserDCHPDataNotifyService )
                DHCPInstance -> UserDCHPDataNotifyService ( UDPSocket , ClientIP , SubNet , GateWay ) ;
              DHCPInstance -> Command = 0;
              if ( Duration != 0xffffffff )
              {
                if ( DHCPInstance -> TimeOutService )
                {
                  DetachTimer ( DHCPInstance -> TimeOutService ) ;
                  DHCPInstance -> TimeOutService = ( void * ) 0 ;
                }   ;
                DHCPInstance -> TimeOutService = AttachTimer ( ( 3 * 1000 * Duration / 4 ) , 
                                                               DHCPLeaveTimeOutNotify , ( void * ) DHCPInstance ) ;
              }   ;
            }   ;
            break ;
          case 6 :
            if ( DHCPInstance -> Command == 3 )
            {
              if ( DHCPInstance -> TimeOutService )
              {
                DetachTimer ( DHCPInstance -> TimeOutService ) ;
                DHCPInstance -> TimeOutService = ( void * ) 0 ;
              }   ;
              SetIPAdresses ( IPLayerInstance , 0 , 0 , 0 ) ;
              DHCPInstance -> Command = 1 ;
              DHCPInstance -> XID ++ ;
              Reply = ( 1 ) ;
            }   ;
            break ;
        }   ;
        if ( Reply )
        {
          DHCPInstance -> TimeOut = ( 5 * 1000 ) ;
          SendDHCPRequest ( DHCPInstance ) ;
        }   ;
      }   ;
    }   ;
  }   ;
}  


static void DHCPTimeOutNotify ( void * CallParam )
{
  PtrDHCPLayerInstanceRecT DHCPInstance ;
   
  DHCPInstance = ( PtrDHCPLayerInstanceRecT ) CallParam ;
  DetachTimer ( DHCPInstance -> TimeOutService ) ;
  DHCPInstance -> TimeOutService = ( void * ) 0 ;
  DHCPInstance -> Command = 0 ;
  DHCPClientRenew ( DHCPInstance ) ;
}  


static USHORT StrLen ( UCHAR * Str )
{
  UCHAR * SaveStr = Str ;
   
  while ( * SaveStr ++ )
    ;
  return ( SaveStr - Str - 1 ) ;
}  


static USHORT SendDHCPRequest ( PtrDHCPLayerInstanceRecT DHCPInstance )
{
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
  PtrIPLayerInstanceRecT IPLayerInstance ;
  EMACInstanceRecT * InterfInstance ;
  PtrOSFrameRecT OutFrame ;
  USHORT LocalDeviceNameSize ;
  USHORT Status ;
   
  UDPLayerInstance = DHCPInstance -> UDPLayerInstance ;
  IPLayerInstance = UDPLayerInstance -> IPLayerInstance ;
  InterfInstance = IPLayerInstance -> InterfaceInstance ;
  OutFrame = InterfInstance -> InterfaceAllocFrameMemory ( sizeof ( OSFrameRecT ) ) ;
  if ( ! OutFrame )
    return ( 1 ) ;
  AddByteField ( OutFrame , 1 ) ;               
  AddByteField ( OutFrame , 1 ) ;                   
  AddByteField ( OutFrame , 6 ) ;              
  AddByteField ( OutFrame , 0 ) ;                              
  AddULONGSwapField ( OutFrame , DHCPInstance -> XID ) ;       
  AddUSHORTSwapField ( OutFrame , 0 ) ;                        
  AddUSHORTSwapField ( OutFrame , 0x8000 ) ;                   
  AddULONGSwapField ( OutFrame , 0 ) ;                         
  AddULONGSwapField ( OutFrame , 0 ) ;                         
  AddULONGSwapField ( OutFrame , 0 ) ;                         
  AddULONGSwapField ( OutFrame , 0 ) ;                         
  AddByteArrayField ( OutFrame , InterfInstance -> InterfaceMACAddress , 6 ) ;
  AddDuplByteField ( OutFrame , 0 , 16 - 6 ) ; 
  AddDuplByteField ( OutFrame , 0 , 64 ) ;   
  AddDuplByteField ( OutFrame , 0 , 128 ) ;    
                                                               
  AddULONGSwapField ( OutFrame , 0x63825363 ) ;          
  AddByteField ( OutFrame , 53 ) ;           
  AddByteField ( OutFrame , 1 ) ;                              
  AddByteField ( OutFrame , DHCPInstance -> Command ) ;        
  AddByteField ( OutFrame , 12 ) ;
  LocalDeviceNameSize = StrLen ( DHCPInstance -> DeviceName ) ;
  AddByteField ( OutFrame , LocalDeviceNameSize ) ;
  AddByteArrayField ( OutFrame , DHCPInstance -> DeviceName , LocalDeviceNameSize ) ;
  if ( DHCPInstance -> Client_IP )
  {
    AddByteField ( OutFrame , 50 ) ;
    AddByteField ( OutFrame , 4 ) ;
    AddULONGSwapField ( OutFrame , DHCPInstance -> Client_IP ) ;
  }   ;
  if ( DHCPInstance -> Command == 3)
  {
    AddByteField ( OutFrame , 54 ) ;
    AddByteField ( OutFrame , 4 ) ;
    AddULONGSwapField ( OutFrame , DHCPInstance -> Server_ID ) ;
  }   ;
  AddByteField ( OutFrame , 55 ) ;
  AddByteField ( OutFrame , 2 ) ;
  AddByteField ( OutFrame , 1 ) ;
  AddByteField ( OutFrame , 3 ) ;
  AddByteField ( OutFrame , 255 ) ;
  if ( OutFrame -> Length < 300 )
  {
    AddDuplByteField ( OutFrame , 0 , 300 - OutFrame -> Length ) ;
  }   ;
traceDHCP(OutFrame -> Data , OutFrame -> Length);
UART0SendString ( ( UCHAR * ) "Powyzszy pakiet DHCP wyslano zakapsulowany jako UDP\r\n" ) ;
  Status = UDPSendData ( DHCPInstance -> DHCPSocket , 0xFFFFFFFF , 67 ,
                         OutFrame -> Data , OutFrame -> Length ) ;
  InterfInstance -> InterfaceDeallocFrameMemory ( OutFrame ) ;
  if ( DHCPInstance -> TimeOutService )
  {
    DetachTimer ( DHCPInstance -> TimeOutService ) ;
  }   ;
  DHCPInstance -> TimeOutService = AttachTimer ( DHCPInstance -> TimeOut , DHCPTimeOutNotify ,
                                                 ( void * ) DHCPInstance ) ;
  return ( Status ) ;
}  


void DHCPClientRenew ( PtrDHCPLayerInstanceRecT DHCPInstance )
{
   
  if ( ! DHCPInstance -> Command )
  {
    DHCPInstance -> XID ++ ;
    DHCPInstance -> Command = 1 ;
    DHCPInstance -> TimeOut = ( 5 * 1000 ) ;
    if ( DHCPInstance -> TimeOutService )
      DetachTimer ( DHCPInstance -> TimeOutService ) ;
    DHCPInstance -> TimeOutService = AttachTimer ( DHCPInstance -> TimeOut , DHCPTimeOutNotify ,
                                                   ( void * ) DHCPInstance ) ;
    SendDHCPRequest ( DHCPInstance ) ;
  }   ;
}  


USHORT StartDHCPService ( PtrDHCPLayerInstanceRecT    DHCPInstance ,
                          RecVDHCPDataNotifyServProcT DataNotifyService )
{
  PtrUDPLayerInstanceRecT UDPLayerInstance ;
  USHORT Status ;
   
  if ( ! DHCPInstance -> DHCPSocket )
  {
    UDPLayerInstance = DHCPInstance -> UDPLayerInstance ;
    DHCPInstance -> UserDCHPDataNotifyService = DataNotifyService ;
    DHCPInstance -> DHCPSocket = CreateUDPSocket ( UDPLayerInstance ) ;
    if ( ! DHCPInstance -> DHCPSocket )
      return ( ( 0 ) ) ;
    Status = BindUDPSocket ( DHCPInstance -> DHCPSocket , 68 ) ;
    if ( Status != 0 )
      return ( ( 0 ) ) ;
    SetUDPListen ( DHCPInstance -> DHCPSocket , DHCPDataRecvNotify ) ;
  }   ;
UART0SendString ( ( UCHAR * ) "DHCPClientRenew ( DHCPInstance ) ; -> start negocjacji DHCP\r\n" ) ;
  DHCPClientRenew ( DHCPInstance ) ;
  return ( ( 1 ) ) ;
}  


void StopDHCPService ( PtrDHCPLayerInstanceRecT DHCPInstance )
{
   
  DHCPInstance -> UserDCHPDataNotifyService = ( void * ) 0 ;
  if ( DHCPInstance -> DHCPSocket )
    DeallocateUDPSocket ( DHCPInstance -> DHCPSocket ) ;
  DHCPInstance -> DHCPSocket = ( void * ) 0 ;
  if ( DHCPInstance -> TimeOutService )
  {
    DetachTimer ( DHCPInstance -> TimeOutService ) ;
    DHCPInstance -> TimeOutService = ( void * ) 0 ;
  }   ;
}  


PtrDHCPLayerInstanceRecT AllocateDHCPClientInstance ( PtrUDPLayerInstanceRecT UDPLayerInstance ,
                                                      UCHAR *                 DeviceIdentifier )
{
  PtrDHCPLayerInstanceRecT DHCPInstance ;
  USHORT Loop ;
  USHORT LocalDeviceNameSize ;
   
  DHCPInstance = & LocalDHCPLayerInstance ;
  DHCPInstance -> UDPLayerInstance = UDPLayerInstance ;
  DHCPInstance -> DHCPSocket = ( void * ) 0 ;
  if ( ! DeviceIdentifier )
  {
    LocalDeviceNameSize = 0 ;
  }  
  else
  {
    LocalDeviceNameSize = StrLen ( DeviceIdentifier ) ;
  }   ;
  for ( Loop = 0 ; Loop < 16 ; Loop ++ )
    DHCPInstance -> DeviceName [ Loop ] = 0 ;
  if ( LocalDeviceNameSize >= 16 )
    LocalDeviceNameSize = 16 - 1 ;
  if ( LocalDeviceNameSize )
  {
    for ( Loop = 0 ; Loop < LocalDeviceNameSize ; Loop ++ )
      DHCPInstance -> DeviceName [ Loop ] = * DeviceIdentifier ++ ;
  }   ;
  DHCPInstance -> Command = 0 ;
  DHCPInstance -> Retry = 0 ;
  DHCPInstance -> Client_IP = 0 ;
  DHCPInstance -> Server_ID = 0 ;
  DHCPInstance -> XID = MagicID ( UDPLayerInstance ) ;
  DHCPInstance -> TimeOut = 0 ;
  DHCPInstance -> TimeOutService = ( void * ) 0 ;
  return ( DHCPInstance ) ;
}  


